VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "API Drives"
   ClientHeight    =   3390
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6240
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3390
   ScaleWidth      =   6240
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.ListView ListView1 
      Height          =   2655
      Left            =   90
      TabIndex        =   1
      Top             =   600
      Width           =   6015
      _ExtentX        =   10610
      _ExtentY        =   4683
      View            =   3
      MultiSelect     =   -1  'True
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      FlatScrollBar   =   -1  'True
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      HotTracking     =   -1  'True
      HoverSelection  =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      Appearance      =   0
      NumItems        =   4
      BeginProperty ColumnHeader(1) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         Text            =   "Drive"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   1
         Text            =   "Volume Name"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(3) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   2
         Text            =   "Drive Type"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(4) {BDD1F052-858B-11D1-B16A-00C0F0283628} 
         SubItemIndex    =   3
         Text            =   "Partition Type"
         Object.Width           =   2540
      EndProperty
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Refresh Drives List"
      Height          =   375
      Left            =   90
      TabIndex        =   0
      Top             =   120
      Width           =   6015
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Declare Function GetLogicalDrives Lib "kernel32" () As Long

Private Declare Function GetLogicalDriveStrings Lib "kernel32" Alias _
"GetLogicalDriveStringsA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

Private Declare Function GetVolumeInformation Lib "kernel32" Alias _
"GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer _
As String, ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, _
lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal _
lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long

Private Declare Function GetDriveType Lib "kernel32" Alias "GetDriveTypeA" _
(ByVal nDrive As String) As Long

Const DRIVE_UNKNOWN = 0
Const DRIVE_REMOVABLE = 2
Const DRIVE_FIXED = 3
Const DRIVE_REMOTE = 4
Const DRIVE_CDROM = 5
Const DRIVE_RAMDISK = 6

Private Sub VolFixedDiskInfo(ByVal drv As String, volfsname As String, _
voltype As String, parttype As String)
Dim fsflags As Long
Dim serial As Long
Dim maxlen As Long
Dim fsname As String * 255
Dim volname As String * 255
Dim drive As String

If Right(drv, Len(drv)) <> "\" Then drive = drv & "\"
Select Case GetDriveType(drive)
    Case DRIVE_UNKNOWN: voltype = "Undetermined"
    Case DRIVE_REMOVABLE: voltype = "Removable Drive"
    Case DRIVE_FIXED: voltype = "Fixed Drive"
    Case DRIVE_REMOTE: voltype = "Network Drive"
    Case DRIVE_CDROM: voltype = "CD-ROM Drive"
    Case DRIVE_RAMDISK: voltype = "RAM Disk"
    Case Else: voltype = ""
End Select
If GetDriveType(drive) = DRIVE_FIXED Then
    If GetVolumeInformation(drive, volname, 255, serial, maxlen, fsflags, fsname, 255) Then
        volfsname = Left(volname, InStr(volname, Chr(0)) - 1)
        parttype = Left(fsname, InStr(fsname, Chr(0)) - 1)
    Else
        volfsname = ""
        parttype = ""
    End If
Else
    volfsname = ""
    parttype = ""
End If
End Sub

Private Sub GetDrivesList()
Dim diskname As String
Dim disk() As String
Dim disknames As String * 255
Dim nDisk As Long
Dim voltype As String
Dim volfsname As String
Dim parttype As String
Dim currentListItem As Long

nDisk = GetLogicalDrives()
errd = GetLogicalDriveStrings(255, disknames)
If errd > 0 Then
    For l = ListView1.ListItems.Count To 1 Step -1
        ListView1.ListItems.Remove l
    Next
    disk = Split(disknames, Chr(0), nDisk)
    currentListItem = 1
    For i = 0 To UBound(disk)
        If Len(disk(i)) > 0 Then
            If Asc(UCase(Left(disk(i), 1))) >= Asc("A") Then
                VolFixedDiskInfo Left(disk(i), 2), volfsname, voltype, parttype
                ListView1.ListItems.Add currentListItem, , UCase(Left(disk(i), 2))
                ListView1.ListItems(currentListItem).ListSubItems.Add , , volfsname
                ListView1.ListItems(currentListItem).ListSubItems.Add , , voltype
                ListView1.ListItems(currentListItem).ListSubItems.Add , , parttype
                currentListItem = currentListItem + 1
            End If
        End If
    Next
End If
End Sub

Private Sub Command1_Click()
GetDrivesList
End Sub

Private Sub Form_Load()
GetDrivesList
End Sub

